/*
      EZ-KIT lite 2181
 ->->  , 
   . 
*/
#include    "def2181.h" //    
#include    "const.h"

  

.SECTION/DM		buf_var1;
.var    rx_buf[3];      /*   + L data + R data */

.SECTION/DM		buf_var2;
.var    	tx_buf[3] = 0xc000,0x0000, 0x0000;      /*  + L data + R data    */
.var flag[1]=0;
.var numb[1]=N_comp;

.SECTION/DM		data1; 
.var    input[taps+1]=0;

.SECTION/DM		data2;
.var    inc[1]=1; 

.SECTION/DM		buf_var3;
.var    init_cmds[13] = 0xc000+GainLeft,     
 /*    AD1847	Left input control reg
                        				b7-6: 0=left line 1
                              			1=left aux 1
                              			2=left line 2
                              			3=left line 1 post-mixed loopback
                        			b5-4: res
                        			b3-0: left input gain x 1.5 dB
                    				*/
        				0xc100+GainRight,     /*
                        				Right input control reg
                        				b7-6: 0=right line 1
                              				1=right aux 1
                              				2=right line 2
                              				3=right line 1 post-mixed loopback
                        				b5-4: res
                        				b3-0: right input gain x 1.5 dB
                    				*/
        				0xc288,     /*
                        				left aux 1 control reg
                        				b7  : 1=left aux 1 mute
                        				b6-5: res
                        				b4-0: gain/atten x 1.5, 08= 0dB, 00= 12dB
                    				*/
        				0xc388,     /*
                        				right aux 1 control reg
                        				b7  : 1=right aux 1 mute
                        				b6-5: res
                        				b4-0: gain/atten x 1.5, 08= 0dB, 00= 12dB
                    				*/
        				0xc488,     /*
                        				left aux 2 control reg
                        				b7  : 1=left aux 2 mute
                        				b6-5: res
                        				b4-0: gain/atten x 1.5, 08= 0dB, 00= 12dB
                    				*/
        				0xc588,     /*
                        				right aux 2 control reg
                        				b7  : 1=right aux 2 mute
                        				b6-5: res
                        				b4-0: gain/atten x 1.5, 08= 0dB, 00= 12dB
                    				*/
        				0xc680+AttLeft,     /*
                        				left DAC control reg
                        				b7  : 1=left DAC mute
                        				b6  : res
                        				b5-0: attenuation x 1.5 dB
                    				*/
        				0xc780+AttRight,     /*
                        				right DAC control reg
                        				b7  : 1=right DAC mute
                        				b6  : res
                        				b5-0: attenuation x 1.5 dB
                    				*/
        				0xc840+Fdiscr,     /*
                        				data format register
                        				b7  : res
                        				b5-6: 0=8-bit unsigned linear PCM
                              				1=8-bit u-law companded
                              				2=16-bit signed linear PCM
                              				3=8-bit A-law companded
                        				b4  : 0=mono, 1=stereo
                        				b0-3: 0=  8.
                              				1=  5.5125
                              				2= 16.
                              				3= 11.025
                              				4= 27.42857
                              				5= 18.9
                              				6= 32.
                              				7= 22.05
                              				8=   .
                              				9= 37.8
                              				a=   .
                              				b= 44.1
                              				c= 48.
                              				d= 33.075
                              				e=  9.6
                              				f=  6.615
                       				(b0) : 0=XTAL1 24.576 MHz; 1=XTAL2 16.9344 MHz
                    					*/
        				0xc909,     /*
                        				interface configuration reg
                        				b7-4: res
                        				b3  : 1=autocalibrate
                        				b2-1: res
                        				b0  : 1=playback enabled
                    				*/
        				0xca00,     /*
                        				pin control reg
                        				b7  : logic state of pin XCTL1
                       					b6  : logic state of pin XCTL0
                        				b5  : master - 1=tri-state CLKOUT
                              				slave  - x=tri-state CLKOUT
                        				b4-0: res
                    				*/
        				0xcc40,     /*1100 1100 0100 0000
	THIS PROGRAM USES 16 SLOTS PER FRAME
                        				miscellaneous information reg
                        				b7  : 1=16 slots per frame, 0=32 slots per frame
                        				b6  : 1=2-wire system, 0=1-wire system
                        				b5-0: res
                    				*/
        				0xcd00;     /*
                        				digital mix control reg
                        				b7-2: attenuation x 1.5 dB
                        				b1  : res
                        				b0  : 1=digital mix enabled
                    				*/

.SECTION/DM		data1;
.var        stat_flag;

/***    ***/   
.SECTION/PM     interrupts;
 		jump start;  rti; rti; rti;     //00: reset      
        rti;         rti; rti; rti;     //04: IRQ2 
        rti;         rti; rti; rti;     //08: IRQL1 
        rti;         rti; rti; rti;     //0c: IRQL0 
        ar = dm(stat_flag);             //10:   SPORT0  
        ar = pass ar;
        if eq rti;
        jump next_cmd;
        jump input_samples;               //14:   SPORT0
                     rti; rti; rti;
        jump irqe;   rti; rti; rti;     /*18: IRQE */
        rti;         rti; rti; rti;     /*1c: BDMA */
        rti;		 rti; rti; rti;     /*20: SPORT1 tx or IRQ1 */
        rti;         rti; rti; rti;     /*24: SPORT1 rx or IRQ0 */
        nop;         rti; rti; rti;     /*28: timer */
        rti;         rti; rti; rti;     //2c:     


.SECTION/PM		seg_code;
.var        coef[taps]="nfcoef.dat";


/*******************************************************************************
 *
 *   ADSP 2181
 *
 *******************************************************************************/
start:
		ax0 = b#0001000000000000;  //sport1 , sport0   
		dm (Sys_Ctrl_Reg) = ax0;
		ena timer;
        i0 = rx_buf;			   //    
        l0 = LENGTH(rx_buf);       //   
        i1 = tx_buf;
        l1 = LENGTH(tx_buf);
        i3 = init_cmds;
        l3 = LENGTH(init_cmds);
        m1 = 1;
        m0 = 0;
    
 /*==================  S E R I A L   P O R T #0 ==================*/
        ax0 = b#0000001010000111;   dm (Sport0_Autobuf_Ctrl) = ax0;
            /*  |||!|-/!/|-/|/|+-    
                |||!|  ! |  | +--    
                |||!|  ! |  +---- |    
                |||!|  ! |        | m1
                |||!|  ! +------- !    
                |||!|  !          ! i0
                |||!|  !          !
                |||!|  +========= |    
                |||!|             | m1
                |||!+------------ !    
                |||!              ! i1
                |||!              !
                |||+============= | BIASRND MAC biased rounding control bit 
                ||+-------------- 0
                |+--------------- | CLKODIS CLKOUT disable control bit
                +---------------- 0
            */

        ax0 = 0;    dm (Sport0_Rfsdiv) = ax0;
            /*   RFSDIV = SCLK Hz/RFS Hz - 1 */
        ax0 = 0;    dm (Sport0_Sclkdiv) = ax0;
            /*   SCLK = CLKOUT / (2  (SCLKDIV + 1) */
         
        ax0 = b#1000011000001111;   dm (Sport0_Ctrl_Reg) = ax0; 
        /*      ||+--/|!||+/+---/ |   
                |||   |!|||       | = 15
                |||   |!|||       |
                |||   |!|||       |
                |||   |!||+====== !     
                |||   |!||        !     
                |||   |!|+-------      0= 0, 1= 1
                |||   |!+--------      0= 0, 1= 1
                |||   |+=========    0=, 1=
                |||   +----------      0=24, 1=32 
                ||+-------------- | 
                ||                |     
                ||                |  ,      
                ||                |  
                |+--------------- ISCLK    0=, 1=
                +----------------  0=, 1=
      
 (ISLCK=0.    16  (0-3),
       .
    .
    . 
    . 
    . 
       .
                */
           
        ax0 = b#0000000000000111;   dm (Sport0_Tx_Words0) = ax0;
            //   0, 1  2   
        ax0 = b#0000000000000111;   dm (Sport0_Tx_Words1) = ax0;
            //   16, 17  18   
        ax0 = b#0000000000000111;   dm (Sport0_Rx_Words0) = ax0;
            //   0, 1  2   
        ax0 = b#0000000000000111;   dm (Sport0_Rx_Words1) = ax0;
           //   16, 17  18  


/*==============     ==============*/
        ax0 = b#0001000000000000;   dm (Sys_Ctrl_Reg) = ax0; //Sys_Ctrl_Reg=(0x3FFF)
            /*  +-/!||+-----/+-/- |        
                |  !|||           | 0
                |  !|||           |
                |  !||+---------- 0
                |  !||            0
                |  !||            0
                |  !||            0
                |  !||            0
                |  !||            0
                |  !||            0
                |  !|+----------- SPORT1  0=FI, FO, IRQ0, IRQ1,..
                |  !+------------ SPORT1 1=
                |  +============= SPORT0 1=
                +---------------- 0
                                  0
                                  0
            */


		ax0=0x7fff;
		dm(Dm_Wait_Reg)=ax0; //   
							 //   
		
        ifc = b#00000011111111;  //   
        nop;


        icntl = b#00000;
            /*    ||||+- | IRQ0: 0=level, 1=edge
                  |||+-- | IRQ1: 0=level, 1=edge
                  ||+--- | IRQ2: 0=level, 1=edge
                  |+---- 0
                  |----- | IRQ nesting: 0=disabled, 1=enabled
            */


        mstat = b#1000000;
            /*    ||||||+- |     =0
                  |||||+-- |   =0
                  ||||+--- | ALU overflow latch mode, 1=sticky
                  |||+---- | AR saturation mode, 1=saturate, 0=wrap
                  ||+----- |    1= 0=
                  |+------ |  
                  +------- |   GO
            */





/*******************************************************************************
 *
 *  ADSP 1847 Codec intialization
 *
 *******************************************************************************/

        //  
        ax0 = 1;
        dm(stat_flag) = ax0;

        //   
        ena ints;
        imask = b#0001000000;
            /*    |||||||||+ | timer
                  ||||||||+- | SPORT1 rec or IRQ0
                  |||||||+-- | SPORT1 trx or IRQ1
                  ||||||+--- | BDMA
                  |||||+---- | IRQE
                  ||||+----- | SPORT0  
                  |||+------ |    SPORT0
                  ||+------- | IRQL0
                  |+-------- | IRQL1
                  +--------- | IRQ2
            */

        ax0 = dm (i1, m1);          //    sport0
        tx0 = ax0;

check_init:
        ax0 = dm (stat_flag);       //      
        af = pass ax0;              //   1  0      
        if ne jump check_init;      //   
       //   AD1847   ACI( ), 
       //   ACI=1 -    
        ay0 = 2; //0000 0000 0000 0010  
check_aci1:
        ax0 = dm (rx_buf);          //
        ar = ax0 and ay0;           
        if eq jump check_aci1;      

check_aci2:
        ax0 = dm (rx_buf);          //  
        ar = ax0 and ay0;
        if ne jump check_aci2;
        idle;

        ay0 = 0xbf3f;               /*    */
        ax0 = dm (init_cmds + 6);
        ar = ax0 AND ay0;
        dm (tx_buf) = ar;
        idle;

        ax0 = dm (init_cmds + 7);   /*   */
        ar = ax0 AND ay0;
        dm (tx_buf) = ar;
		idle;


        ifc = b#00000011111111;     /*    */
        nop;

		imask = b#0000110000;       /*    SPORT0 */
            /*    |||||||||+ | timer
                  ||||||||+- | SPORT1 rec or IRQ0
                  |||||||+-- | SPORT1 trx or IRQ1
                  ||||||+--- | BDMA
                  |||||+---- | IRQE
                  ||||+----- | SPORT0 rec
                  |||+------ | SPORT0 trx
                  ||+------- | IRQL0
                  |+-------- | IRQL1
                  +--------- | IRQ2
            */


talk: idle;             //  
// 		  
jump  talk;	            //         
        				// 	
/*------------------------------------------------------------------------------
 -
 -    -  SPORT0 
 -
 ------------------------------------------------------------------------------*/

input_samples:
//  
 		ay0 = dm(numb);      // ay0  <-            
        ax0 = 0x0001;        // ax0  <-                        
        ar  = ay0 - ax0;     //    1                  
        dm(numb) = ar;       // numb <-        
        if gt rti;           //    0,             
        ar = N_comp;         // ar   <-   -  
        dm(numb) = ar;       // numb <-   -  
		
	    ena sec_reg;                //  
		ax0 = dm(rx_buf + 1);       //      
		ay0 = dm(rx_buf + 2);       //     
		
   	   
//------------------------------------------------
//  
//-------------------------------->>>>
//	dm(inc)=ay0;
	MR=0;
	ar=dm(flag);		//--      
	none=pass ar;			//---^
if gt jump enter;		//-----^  flag > 0  i  m  	
	I2=input;				//  
	M0=0;					//DM - input 	
	L2=length(coef);		//
	si=1;
	dm(flag)=si;
enter:
	I4=coef;					//	
	L4=length(coef);			//PM - coef
	M4=1;
	dm(I2,M1)=ax0;		
	MX0=DM(I2,M1);
	MY0=PM(I4,M4);
	CNTR=length(coef)-1;
DO end  until CE;	
		
end: MR=MR+MX0*MY0(SS),MX0=DM(I2,M1),MY0=PM(I4,M4);//;
	 MR=MR+MX0*MY0(rnd); //  
	 IF MV SAT MR; //   MR    MR max(min) 	
sr = ashift mr1 by 1 (lo);  /*amplify filtered signal by 2 */
 	mr1=sr0;
//	ay0=dm(inc);
	
   	dm (tx_buf + 1) =mr1;      //      	
	dm (tx_buf + 2) = mr1;     //   
rti;          				//                      

/*------------------------------------------------------------------------------
 -
 -    AD1847
 -
 ------------------------------------------------------------------------------*/
next_cmd:
        ena sec_reg;  
        ax0 = dm (i3, m1);          //      
        dm (tx_buf) = ax0;          //         
        ax0 = i3;
        ay0 = init_cmds;
        ar = ax0 - ay0;
        if gt rti;                  //    AD1847
        ax0 = 0xaf00;               //    AD1847
        dm (tx_buf) = ax0;          // MCE
        ax0 = 0;
        dm (stat_flag) = ax0;       //  
        rti;
//-----------------------------------------------------------------
irqe:
	ar=dm(flag);		//--      
	none=pass ar;		//---^
if eq jump lamp;		//   -  
						//  ,    
 	set fl1;			//
rti;

lamp:
	toggle fl1;             //  fl1 lamp light
rti;


